﻿/*
 * Description: 指定したレイヤーセットを表示／非表示させる
 * Author: msdfjp
 * Version: 1.0.0
 * CreateDate: 2012/03/10
 * Author URI: http://msdf.jp/
 * Copyright: Copyright 2012 msdfjp
*/

//レイヤーセットの接頭辞
var prefix;

//表示／非表示
var isVisible;

//ダイアログを取得
var myDialog = new createDialog(); 

//ダイアログの初期化を実行
initBuilder(myDialog);

//ダイアログの実行結果がtrueならば実行
if(runBuilder(myDialog)){
	runProcessing(myDialog);
}

//ダイアログの生成
function createDialog(){
	var dialogResource = "dialog { text:'レイヤーセットの表示／非表示', bounds:[0, 0, 210, 230], "
    
	dialogResource += " pnl1: Panel { text:'レイヤーセットの接頭辞', bounds:[15, 10, 195, 83], "
	dialogResource += " prefix: EditText { bounds:[15, 23, 160, 44],  }, "
	dialogResource += " }," 

    dialogResource += " pnl2: Panel { text:'表示／非表示', bounds:[15, 95, 195, 168], "
    dialogResource += " _visible: RadioButton { text:'表示', bounds:[15, 25, 65, 46],  }, "
    dialogResource += " _unvisible: RadioButton { text:'非表示', bounds:[95, 25, 175, 46],  }, "
    dialogResource += " }," 

    dialogResource += " cancel: Button { text:'キャンセル', bounds:[15, 190, 100, 214],  }, "
    dialogResource += " build: Button { text:'実行', bounds:[110, 190, 195, 214],  }, "
    
	dialogResource += " }";

	var dlg = new Window( dialogResource );
	dlg.center();
	return dlg;
}

//ダイアログの初期化
function initBuilder(builder){
    with(builder){
        pnl1.prefix.text = "_";
        pnl2._visible.value = true;
        cancel.onClick = function(){ this.parent.close( false ); };
        build.onClick = function(){ this.parent.close( true ); };
    }
}

// ダイアログ（起動・実行）
function runBuilder(builder){
  return builder.show();
}

//ダイアログから値を取得
function runProcessing(builder){
	with(builder){
		prefix = pnl1.prefix.text;
        
        if (pnl2._visible.value == true) {
            isVisible = true;
        } else if (pnl2._unvisible.value == true) {
            isVisible = false;
        }
    }

    setVisibility(activeDocument);
}

//ラベル名が「レイヤーセットの接頭辞」で始まるレイヤーセットをすべて「表示／非表示」させる
function setVisibility(layObj){

    var ns = layObj.layerSets.length;
    
    for (var i=0; i<ns; i++){
        if(layObj.layerSets[i].name.substring(0, prefix.length) == prefix){
            layObj.layerSets[i].visible = isVisible;
        }
        setVisibility(layObj.layerSets[i])

    }

}
